![](https://github.com/openmainframeproject/artwork/raw/master/projects/cobol-programming-course/cobol-programming-course-color.png)

![License](https://img.shields.io/github/license/OpenMainframeProject/cobol-programming-course)

# COBOL Programming Course

This project is a set of training materials and labs for COBOL on z/OS. The following books are available within this repository. To get started, follow the steps in their respective READMEs.

- Released
    - [COBOL Programming Course #1 - Getting Started](COBOL%20Programming%20Course%20%231%20-%20Getting%20Started/README.md)

- Incubation
    - [COBOL Programming Course #2 - Advanced Topics](COBOL%20Programming%20Course%20%232%20-%20Advanced%20Topics/README.md)
    - [COBOL Programming Course #3 - Testing](COBOL%20Programming%20Course%20%233%20-%20Testing/README.md)

If you run into any issues, please don't hesitate to reach out on our [slack channel](https://openmainframeproject.slack.com/archives/C011NE32Z1T).

## Discussion

You can connect with the community in a variety of ways...

- [#cobol-programming-course channel on Open Mainframe Project Slack](https://slack.openmainframeproject.org)
- ['COBOL technical questions' category on Open Mainframe Project Community Forums](https://community.openmainframeproject.org/c/cobol-technical-questions/16)
- [COBOL Programming Course Discussion Mailing list](https://lists.openmainframeproject.org/g/cobol-course-discussion)

## Contributing

Pull requests are welcome. For major changes, please open an issue first to discuss what you would like to change.

All contributions must align with the [Open Mainframe Project contribution guidelines](https://github.com/openmainframeproject/tac/blob/master/process/contribution_guidelines.md), including having a DCO signoff on all commits.

## Governance

This project is openly governed as defined in [GOVERNANCE.md](GOVERNANCE.md).

## Credits

The courseware materials were made available through a joint collaboration IBM, it's clients, and American River College and proposed as a new project by IBM.

## Video Course Links

- [IBM Digital Learning Platform](https://learn.ibm.com/course/view.php?id=7552)
- [Coursera](https://www.coursera.org/learn/cobol-programming-vscode?)
- [Pluralsight](https://www.pluralsight.com/courses/learning-cobol-programming-vscode)
- [YouTube](https://www.youtube.com/watch?v=RdMAEdGvtLA)
