### COBOL Programming Resources
[COBOL Resource hub on IBM Developer](https://developer.ibm.com/technologies/cobol/)

[COBOL Fridays Replay videos and link to register for future events](https://developer.ibm.com/technologies/cobol/series/cobol-fridays-webinar-videos)

YouTube Video: [So you want to learn COBOL?](https://youtu.be/77o14aHUuSo)

[IBM Enterprise COBOL for z/OS Documentation Library](https://www.ibm.com/support/pages/enterprise-cobol-zos-documentation-library) - Full Reference Library of COBOL Manuals

[IBM Enterprise COBOL for z/OS,  Language Reference v6.3](http://publibfp.boulder.ibm.com/epubs/pdf/igy6lr30.pdf)

[IBM Language Environment Programming Reference v2r4](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zosV2R4SA380683/$file/ceea300_v2r4.pdf) - Common subroutines callable from all IBM supported programming languages.

[IBM Enterprise COBOL for z/OS, Messages and Codes v6.3](http://publibfp.boulder.ibm.com/epubs/pdf/c2746481.pdf)

### Zowe Resources

[Installing Zowe CLI from an online registry](https://docs.zowe.org/v1-1-x/user-guide/cli-installcli.html#installing-zowe-cli-from-a-local-package)

[Installing Zowe CLI from source](https://github.com/zowe/zowe-cli#install-zowe-cli-from-source)

[An Introduction to the Zowe Virtual Desktop](https://medium.com/zowe/an-introduction-to-the-zowe-virtual-desktop-6e0140644875)

### General z/OS Resources

[IBM z/OS MVS JCL Reference v2r4](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zOSV2R4sa231385/$file/ieab600_v2r4.pdf)

[IBM z/OS Communications Server: IP User's Guide and Commands v2r4](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zOSV2R4sc273662/$file/halu001_v2r4.pdf) - FTP Reference Manual

[IBM z/OS TSO/E REXX Reference v2r4](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zOSV2R4sa320972/$file/ikja300_v2r4.pdf)

[Timeline and brief description of IBM Operating Systems.](https://webfiles.uci.edu/scosel/_$OSTL37.5.pdf) By Dave Morton, marspyrs. Dated: February, 2018

### Additional Training & Hands-on Opportunities

[z/OS Introduction and Workshop for IT Professionals](http://ibm.biz/zOSclass)

[Master the Mainframe - Get hands-on Experience Across a Variety of Technologies](https://www.ibm.com/it-infrastructure/z/education/master-the-mainframe)

[Beginner’s Guide: COBOL Made Easy](https://medium.com/modern-mainframe/beginners-guide-cobol-made-easy-introduction-ecf2f611ac76) by Jessielaine Punongbayan

### DFSORT

[IBM DFSORT: ICETOOL Mini-User Guide](https://www.ibm.com/support/pages/sites/default/files/inline-files/$FILE/sorttool.pdf) - October, 2010 by Frank L. Yaeger

[DFSORT′s Year 2000 Features (The New Generation)](https://www.ibm.com/support/pages/sites/default/files/inline-files/$FILE/sort2000.pdf) - October, 1998 by Frank L. Yaeger

[IBM DFSORT Application Programming Guide v2r4](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zOSV2R4sc236878/$file/icea100_v2r4.pdf) - Full Manual

Note: IBM DFSORT's ICETOOL can often replace the need to write COBOL program(s), when needing to (optionally) sort and tranform data contained in one or more input files to produce an output file.  All user guides written by Frank L. Yaeger on this subject are excellent.

### Additional Resources

[IBM Setting property groups | IBM Z® Open Editor](https://ibm.github.io/zopeneditor-about/Docs/setting_propertygroup.html#mvs-property-groups-using-the-zowe-cli)

[Want to become a Tech Entrepreneur? Here’s how I did it & you can too](https://ibm.webex.com/recordingservice/sites/ibm/recording/play/16546b7dc0274b90a313f2fbe1f86706)- Webinar - Originally broadcast: 2020-04-23 - 1 hour

[IBM Z and LinuxONE Community](https://www.ibm.com/community/z/)

[Open Mainframe Project Website - The Linux Foundation Projects](https://www.openmainframeproject.org/)

[IBM and Open Mainframe Project Mobilize to Connect States with COBOL Skills](https://newsroom.ibm.com/2020-04-09-IBM-and-Open-Mainframe-Project-Mobilize-to-Connect-States-with-COBOL-Skills)

[Dr. David Woolbright's (COBOL Fridays: Presenter) Website](https://punctiliousprogrammer.com/)

[DB2 SQL Cookbook](http://db2-sql-cookbook.org/pdf/Db2_SQL_Cookbook.pdf) based upon the original work of Graeme Birchall:

[DB2 SQL Cookbook - Original Archived PDF](https://web.archive.org/web/20130115084328/http://mysite.verizon.net/Graeme_Birchall/cookbook/DB2V97CK.PDF)

[Fake Your Way Through Minis and Mainframes - Including MVS (predecessor to z/OS)](http://www.snee.com/bob/opsys.html)

### Employment Opportunity - Cobol Programmers Needed Now!

[State of New Jersey](https://forms.business.nj.gov/tech/)
